#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> adj(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        adj[u - 1].push_back(v - 1);
        adj[v - 1].push_back(u - 1);
    }

    vector<pair<int,int>> g(k);
    for (int i = 0; i < k; ++i) cin >> g[i].first >> g[i].second, g[i].first--;

    vector<bool> p(n);
    for (auto& [s, d] : g) {
        queue<pair<int, int>> q;
        q.push({s, 0});
        vector<bool> v(n);
        v[s] = 1;
        while (!q.empty()) {
            auto [u, dist] = q.front(); q.pop();
            if (dist <= d) p[u] = 1;
            for (int to : adj[u]) if (!v[to]) q.push({to, dist + 1}), v[to] = 1;
        }
    }

    int c = 0;
    for (bool b : p) c += b;
    cout << c << endl;
    for (int i = 0; i < n; ++i) if (p[i]) cout << i + 1 << (i == n -1 || !p[i+1] ? "" : " ");
    cout << endl;
    return 0;
}
